unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Menus, IniFiles, ExtCtrls, ShellApi, XPMan,

  kuTray,
  kuModul;


type
  TForm1 = class(TkuForm)
    pmTray: TPopupMenu;
    pm_Close: TMenuItem;
    pm_MinimizeToTray: TMenuItem;
    ch_RunMinimizedToTray: TCheckBox;
    pm_FullScreen: TMenuItem;
    Panel_Minimize: TPanel;
    Label1: TLabel;
    ch_MinimizeToTrayR: TCheckBox;
    CheckBox2: TCheckBox;
    ch_MinimizeToBarL: TCheckBox;
    Panel1: TPanel;
    Label10: TLabel;
    ch_CloseToTrayR: TCheckBox;
    CheckBox1: TCheckBox;
    ch_CloseToTray: TCheckBox;
    cb_IconOnRestore: TComboBox;
    lab_OnRestoreIcon: TLabel;
    Panel3: TPanel;
    Label2: TLabel;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    pm_ShowForm2: TMenuItem;
    N1: TMenuItem;
    pm_top1: TMenuItem;
    ch_CloseTotrayByEsc: TCheckBox;
    btnMail: TButton;
    btnMinimizeToTray: TButton;

    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);

    procedure cb_IconOnRestoreChange(Sender: TObject);

    procedure ch_CloseToTrayClick(Sender: TObject);

    procedure pm_CloseClick(Sender: TObject);
    procedure pm_MinimizeToTrayClick(Sender: TObject);
    procedure pm_FullScreenClick(Sender: TObject);
    procedure pm_ShowForm2Click(Sender: TObject);
    procedure pm_top1Click(Sender: TObject);

    procedure btnMailClick(Sender: TObject);
    procedure btnMinimizeToTrayClick(Sender: TObject);

  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

uses Unit2;




{$REGION '   Form1   '}



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Show
procedure TForm1.FormShow(Sender: TObject);
begin

if not _FirstStart then exit;

_FirstStart := False;

ShowIconIn(_IconIn);

end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Destroy
procedure TForm1.FormDestroy(Sender: TObject);
var ini : TIniFile;

begin

ini := TiniFile.Create( ExtractFilePath(Application.ExeName) + 'settings.ini' );

try
  ini.Writebool     ( 'Settings', 'RunMinimizedToTray', ch_RunMinimizedToTray.Checked  );
  ini.Writebool     ( 'Settings', 'CloseTotray',        ch_CloseToTray.Checked         );
  ini.WriteInteger  ( 'Settings', 'IconIn',             IconInToInt                    );

finally
  ini.Free;
end;

end;




{$ENDREGION}





//------------------------------------------------------------------------------ OnRestore Icon
procedure TForm1.cb_IconOnRestoreChange(Sender: TObject);
begin

_IconIn := IntToIconIn(Form1.cb_IconOnRestore.ItemIndex);
ShowIconIn(_IconIn);
SetForegroundWindow(Self.Handle);

end;



//------------------------------------------------------------------------------
procedure TForm1.btnMinimizeToTrayClick(Sender: TObject);
begin
MinimizeToTray;
end;



//------------------------------------------------------------------------------ Close To Tray
procedure TForm1.ch_CloseToTrayClick(Sender: TObject);
begin

Form1.CloseToTray := ch_CloseToTray.Checked;

end;



//------------------------------------------------------------------------------ 
procedure TForm1.btnMailClick(Sender: TObject);
begin
ShellExecute(Form1.Handle, nil, _kuSait, nil, nil, SW_SHOWNORMAL);
end;









{$REGION '   pm   '}



//------------------------------------------------------------------------------ Close
procedure TForm1.pm_CloseClick(Sender: TObject);
begin
Form1.Close;
end;


//------------------------------------------------------------------------------ Full Screen
procedure TForm1.pm_FullScreenClick(Sender: TObject);
begin

case Self.BorderStyle
of

  bsNone:
      Self.BorderStyle := bsSizeable;


  bsSizeable:
      begin
        Self.BorderStyle := bsNone;

        case Self.WindowState
        of
          wsNormal: Self.WindowState := wsMaximized;

          wsMaximized:
          begin
             Self.WindowState := wsNormal;
             Self.WindowState := wsMaximized;
          end;
        end;
      end;

end;


end;


//------------------------------------------------------------------------------ Esc
procedure TForm1.pm_MinimizeToTrayClick(Sender: TObject);
begin

if not ch_CloseTotrayByEsc.Checked then exit;

MinimizeToTray;

end;


//------------------------------------------------------------------------------ Form 2
procedure TForm1.pm_ShowForm2Click(Sender: TObject);
begin
Form2.Show;
//Form2.Caption := inttostr(Form2.Handle);
end;


//------------------------------------------------------------------------------ Handle
procedure TForm1.pm_top1Click(Sender: TObject);
begin

ShowMessage('Application.Handle = '+inttostr(Application.Handle)+#13#10+
            'Application.MainFormHandle = '+ inttostr(Application.MainFormHandle)+#13#10+
            'GetActiveWindow = '+ inttostr(GetActiveWindow)+#13#10+
            'GetForegroundWindow = '+inttostr(GetForegroundWindow)
            );

end;


{$ENDREGION}










end.
