unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ActnList, XPStyleActnCtrls, ActnMan, ImgList, ToolWin,
  ActnCtrls, ActnMenus, ComCtrls, StdCtrls, Grids, Menus, ActnPopup, ShellAPI,
  IniFiles, kuTray;

type
  TForm1 = class(TkuForm)
    Panel_MainMenu: TPanel;
    Panel_Work: TPanel;
    Split_X: TSplitter;
    Panel_L: TPanel;
    Panel_R: TPanel;
    ImageList1: TImageList;
    MM: TActionMainMenuBar;
    ActionManager1: TActionManager;
    Act_File_New: TAction;
    Act_File_Open: TAction;
    Act_File_Save: TAction;
    Act_File_Close: TAction;
    Act_File_Import: TAction;
    Act_File_Export: TAction;
    Act_Set_Settings: TAction;
    Act_Set_Lng: TAction;
    Act_Set_Autostart: TAction;
    Act_Set_AutoOpenLastFile: TAction;
    Act_Program_About: TAction;
    Act_Program_OpenInExplorer: TAction;
    Act_Debug: TAction;
    Act_File_OpenInExplorer: TAction;
    Act_File_Inf: TAction;
    Act_Program_Mail: TAction;
    Act_Program_Help: TAction;
    Act_Program_MinimizeToTray: TAction;
    Act_Program_Maximize: TAction;
    Act_Program_Close: TAction;
    Act_File_SaveAs: TAction;
    Act_File_Recent_SUB: TAction;
    Panel_All: TPanel;
    Act_Set_RunMinimizedToTray: TAction;
    pmTray: TPopupMenu;
    Close1: TMenuItem;
    Act_Program_FullScreen: TAction;
    About1: TMenuItem;
    N1: TMenuItem;
    Memo1: TMemo;
    Act_Program_Sait: TAction;
    Act_Set_CloseToTray: TAction;
    Act_OpenSettingsIni: TAction;
    Act_OpenLanguageLng: TAction;


    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);

    procedure Act_Program_MaximizeExecute(Sender: TObject);
    procedure Act_Program_MinimizeToTrayExecute(Sender: TObject);
    procedure Act_Program_OpenInExplorerExecute(Sender: TObject);
    procedure Act_Program_MailExecute(Sender: TObject);
    procedure Act_Program_CloseExecute(Sender: TObject);

    procedure Act_Set_SettingsExecute(Sender: TObject);
    procedure Act_Set_LngExecute(Sender: TObject);
    procedure Act_DebugExecute(Sender: TObject);
    procedure Act_Program_AboutExecute(Sender: TObject);
    procedure Act_Program_FullScreenExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Act_Set_AutostartExecute(Sender: TObject);
    procedure Panel_WorkCanResize(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
    procedure Act_Program_SaitExecute(Sender: TObject);
    procedure Act_Set_CloseToTrayExecute(Sender: TObject);
    procedure Act_OpenSettingsIniExecute(Sender: TObject);
    procedure Act_OpenLanguageLngExecute(Sender: TObject);
    procedure Act_Set_RunMinimizedToTrayExecute(Sender: TObject);

             
  private
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;

  end;

var
  Form1: TForm1; 
  _File_Path : string;


implementation

uses
kuModul,
iLanguage,
kuLanguageUni,
kuShell,
About,
Settings,
kuY,
Individual;


{$R *.dfm}



{$REGION          '   Form1   '}




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Create
procedure TForm1.FormCreate(Sender: TObject);
begin

Form1.Caption := _Program_NVC;

end;




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Show
procedure TForm1.FormShow(Sender: TObject);
begin

if not _FirstStart then exit;

_FirstStart := False;

ShowIconIn(_IconIn);

end;




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Close
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var ini : TIniFile;

begin


Form_iniSave(Form1, Form1.Name);


ini := TiniFile.Create( ExtractFilePath(Application.ExeName) + 'settings.ini' );

try

  ini.Writebool    ( 'Settings', 'AutoOpenLastFile', Act_Set_AutoOpenLastFile.Checked    );
  ini.Writebool    ( 'Settings', 'RunMinimized',     Act_Set_RunMinimizedToTray.Checked  );
  ini.WriteBool    ( 'Settings', 'Autostart',        Act_Set_Autostart.Checked           );
  ini.WriteInteger ( 'Settings', 'Split_Z',          Panel_R.Width                       );
  ini.WriteBool    ( 'Settings', 'CloseToTray',      Act_Set_CloseToTray.Checked         );

//  ini.WriteINteger  ( 'Settings', 'IconIn', FormSettings.cb_IconOnRestore.ItemIndex  );
  case _IconIn
  of
    inNone:       ini.WriteInteger ( 'Settings', 'IconIn', 0);
    inBar:        ini.WriteInteger ( 'Settings', 'IconIn', 1);
    inTray:       ini.WriteInteger ( 'Settings', 'IconIn', 2);
    inBarAndTray: ini.WriteInteger ( 'Settings', 'IconIn', 3);
  end;


finally
  ini.Free;
end;

ShowIconIn(inNone);

end;




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Drop
procedure TForm1.WMDropFiles(var Msg: TWMDropFiles);
//uses ShellApi, Messages, Windows;
const
  maxlen = 254;
  
var

  count : integer;
  h: THandle;
  s: string;
  pchr: array[0..maxlen] of char;
  
  
  
begin
          
h := Msg.Drop;
  
//      ,
//      ,   :
{
num := DragQueryFile(h, Dword(-1), nil, 0);
for i := 0 to num-1
do
begin
     DragQueryFile(h, i, pchr, maxlen);
     ... ...
end;
}

count := DragQueryFile(h, Dword(-1), pchr, maxlen);
if count <> 1
then
begin
    YY(_File_DragDropCan1);
    exit;
end;
  
  
DragQueryFile(h, 0, pchr, maxlen);
s := string(pchr);   
  
  
if FileExists(s) = False
then
begin
    YY(s +AZ+ _File_NotExist);
    exit;
end;



  
if lowercase( extractfileext(s) ) = '.lng'
then
begin
    Lng_SETUP(s, true);
    exit;
end;
  
  

YY(_File_DragDropCanFiles, 'Drag & Drop');
  
  
DragFinish(h); //???
  
  
end;




//------------------------------------------------------------------------------
procedure TForm1.Panel_WorkCanResize(Sender: TObject; var NewWidth, NewHeight: Integer; var Resize: Boolean);
begin

//    alClient
if Panel_L.Width > NewWidth - 10
then Panel_L.Width := NewWidth - 100

end;



{$ENDREGION}




{$REGION          '   Program   '}



//============================================================================== Mail
procedure TForm1.Act_Program_MailExecute(Sender: TObject);
begin
Link_MailTo(_Program_MailAdres, _Program_Name);
end;


//============================================================================== Sait
procedure TForm1.Act_Program_SaitExecute(Sender: TObject);
begin
Link_Execute(_Program_SaitAdres);
end;


//============================================================================== Goto Dir
procedure TForm1.Act_Program_OpenInExplorerExecute(Sender: TObject);
begin
Link_FolderOpenAndFileSelect(Application.ExeName);
end;


//============================================================================== Min
procedure TForm1.Act_Program_MinimizeToTrayExecute(Sender: TObject);
begin
MinimizeToTray;
end;


//============================================================================== Max
procedure TForm1.Act_Program_MaximizeExecute(Sender: TObject);
begin

if Form1.WindowState = wsNormal
  
then//
begin
  Form1.WindowState := wsMaximized;
end

else//
begin
  if Form1.BorderStyle = bsNone
  then Act_Program_FullScreen.Execute
  else Form1.WindowState := wsNormal;
end

end;


//============================================================================== Full Screen
procedure TForm1.Act_Program_FullScreenExecute(Sender: TObject);
begin

Form_FullScreen(Form1);

Form1.Repaint;
Panel_MainMenu.Repaint;
MM.Repaint;

end;


//============================================================================== About
procedure TForm1.Act_Program_AboutExecute(Sender: TObject);
begin
AboutExecute;
end;
             

//============================================================================== Close
procedure TForm1.Act_Program_CloseExecute(Sender: TObject);
begin
Close
end;




{$ENDREGION}




{$REGION          '   Set   '}




//------------------------------------------------------------------------------ Lng
procedure TForm1.Act_Set_LngExecute(Sender: TObject);
var s, t : string;

begin

if _Lng_Path = ''
then s := Path_App
else s := ExtractFilePath(_Lng_Path);

if Dia_File_Open( _Lng_ChooseFile, _Lng_Filter, s, t ) = False then exit;


if FileExists(t)
then Lng_SETUP(t, true)

end;








//------------------------------------------------------------------------------ Run minimized to Tray
procedure TForm1.Act_Set_RunMinimizedToTrayExecute(Sender: TObject);
begin
//
end;




//------------------------------------------------------------------------------ Autostart
procedure TForm1.Act_Set_AutostartExecute(Sender: TObject);
begin

if Act_Set_Autostart.Checked
then Autostart_Add   (_Program_Name, Application.ExeName)
else Autostart_Delete(_Program_Name, Application.ExeName);

end;




//------------------------------------------------------------------------------ Set
procedure TForm1.Act_Set_SettingsExecute(Sender: TObject);
begin
SettingsRun;
end;




//------------------------------------------------------------------------------ Setting.ini
procedure TForm1.Act_OpenLanguageLngExecute(Sender: TObject);
begin
Link_Execute( _Lng_Path );
end;


//------------------------------------------------------------------------------ Language.lng
procedure TForm1.Act_OpenSettingsIniExecute(Sender: TObject);
begin
Link_Execute( Path_App + 'settings.ini'  );
end;


{$ENDREGION}







procedure TForm1.Act_Set_CloseToTrayExecute(Sender: TObject);
begin
Form1.CloseToTray := Act_Set_CloseToTray.Checked;
end;

procedure TForm1.Act_DebugExecute(Sender: TObject);
begin
yy(inttostr(mm.ControlCount));
end;


end.
